<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWsPointAccessDeviceId ArrayType
 * @subpackage Arrays
 */
class ArrayOfWsPointAccessDeviceId extends AbstractStructArrayBase
{
    /**
     * The WsPointAccessDeviceId
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\WsPointAccessDeviceId[]
     */
    public $WsPointAccessDeviceId;
    /**
     * Constructor method for ArrayOfWsPointAccessDeviceId
     * @uses ArrayOfWsPointAccessDeviceId::setWsPointAccessDeviceId()
     * @param \CustomerManagement\StructType\WsPointAccessDeviceId[] $wsPointAccessDeviceId
     */
    public function __construct(array $wsPointAccessDeviceId = array())
    {
        $this
            ->setWsPointAccessDeviceId($wsPointAccessDeviceId);
    }
    /**
     * Get WsPointAccessDeviceId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId[]|null
     */
    public function getWsPointAccessDeviceId()
    {
        return isset($this->WsPointAccessDeviceId) ? $this->WsPointAccessDeviceId : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWsPointAccessDeviceId method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWsPointAccessDeviceId method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWsPointAccessDeviceIdForArrayConstraintsFromSetWsPointAccessDeviceId(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem) {
            // validation for constraint: itemType
            if (!$arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem instanceof \CustomerManagement\StructType\WsPointAccessDeviceId) {
                $invalidValues[] = is_object($arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem) ? get_class($arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem) : sprintf('%s(%s)', gettype($arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem), var_export($arrayOfWsPointAccessDeviceIdWsPointAccessDeviceIdItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WsPointAccessDeviceId property can only contain items of type \CustomerManagement\StructType\WsPointAccessDeviceId, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WsPointAccessDeviceId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\WsPointAccessDeviceId[] $wsPointAccessDeviceId
     * @return \CustomerManagement\ArrayType\ArrayOfWsPointAccessDeviceId
     */
    public function setWsPointAccessDeviceId(array $wsPointAccessDeviceId = array())
    {
        // validation for constraint: array
        if ('' !== ($wsPointAccessDeviceIdArrayErrorMessage = self::validateWsPointAccessDeviceIdForArrayConstraintsFromSetWsPointAccessDeviceId($wsPointAccessDeviceId))) {
            throw new \InvalidArgumentException($wsPointAccessDeviceIdArrayErrorMessage, __LINE__);
        }
        if (is_null($wsPointAccessDeviceId) || (is_array($wsPointAccessDeviceId) && empty($wsPointAccessDeviceId))) {
            unset($this->WsPointAccessDeviceId);
        } else {
            $this->WsPointAccessDeviceId = $wsPointAccessDeviceId;
        }
        return $this;
    }
    /**
     * Add item to WsPointAccessDeviceId value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\WsPointAccessDeviceId $item
     * @return \CustomerManagement\ArrayType\ArrayOfWsPointAccessDeviceId
     */
    public function addToWsPointAccessDeviceId(\CustomerManagement\StructType\WsPointAccessDeviceId $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\WsPointAccessDeviceId) {
            throw new \InvalidArgumentException(sprintf('The WsPointAccessDeviceId property can only contain items of type \CustomerManagement\StructType\WsPointAccessDeviceId, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WsPointAccessDeviceId[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\WsPointAccessDeviceId|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WsPointAccessDeviceId
     */
    public function getAttributeName()
    {
        return 'WsPointAccessDeviceId';
    }
}
